type ('a, 'b) prod =
| Pair of 'a * 'b

val add_r1 :
  ('a1 -> 'a1 -> 'a1) -> ('a1, 'a1) prod -> ('a1, 'a1) prod -> ('a1, 'a1)
  prod

val mul_r1 : ('a1 -> 'a1 -> 'a1) -> 'a1 -> ('a1, 'a1) prod -> ('a1, 'a1) prod

val tensor_r2 :
  ('a1 -> 'a1 -> 'a1) -> ('a1, 'a1) prod -> ('a1, 'a1) prod -> (('a1, 'a1)
  prod, ('a1, 'a1) prod) prod

val add_r2 :
  ('a1 -> 'a1 -> 'a1) -> (('a1, 'a1) prod, ('a1, 'a1) prod) prod -> (('a1,
  'a1) prod, ('a1, 'a1) prod) prod -> (('a1, 'a1) prod, ('a1, 'a1) prod) prod

val mul_r2 :
  ('a1 -> 'a1 -> 'a1) -> 'a1 -> (('a1, 'a1) prod, ('a1, 'a1) prod) prod ->
  (('a1, 'a1) prod, ('a1, 'a1) prod) prod

